/**************************************************************************************************
          FTP.
      "".
  SQL  2008   "COMPRESSION"   BACKUP.
Backup  ,            FTP
   @FtpFolder\@ServerName\DataBaseName\Base
Base  2010_07_19___22_30_DataBaseName.bak
        ,  
"WHERE"   .
        ,     .
    SQL Server   ...
**************************************************************************************************/
DECLARE
@DataBaseName SYSNAME,									--     (  )
@BackUpPath SYSNAME,									--    bak-     
@DirPath SYSNAME,									--        
@FileName SYSNAME,									--  
@BackUpPrefix SYSNAME,									--     bak-  cab- ,   
@year varchar (4), @month varchar (2), @day varchar (2), -- ,        
@hour varchar (2), @min varchar (2),					--    
@FtpServer SYSNAME,
@FtpUser SYSNAME,
@FtpPassword SYSNAME,
@FtpPort SYSNAME,
@FtpFolder SYSNAME
,
@Command SYSNAME,
@S SYSNAME,
@result int
,
@MailForError SYSNAME,
@ServerName SYSNAME


-->>**************************************************************************************
SET @DirPath			= 'C:\Temp\'						--    
SET @FtpServer			= 'ftpserver'						--  FTP-
SET @FtpUser			= 'ftp'							--   FTP-
SET @FtpPassword		= '12345'						--   FTP-
SET @FtpPort			= '21'							--  FTP-
SET @FtpFolder			= '_BackUp'						--   FTP    
SET @MailForError		= 'mail@mail.ru'					-- Email       
SET @ServerName			= 'comp14' 						--     
--<<**************************************************************************************

--     ,   :
SET @year = CAST(DATEPART(Year, GetDate()) AS varchar)
SET @month = CAST(DATEPART(Month, GetDate()) AS varchar)
SET @day = CAST(DATEPART(Day, GetDate()) AS varchar)
SET @hour = CAST(DATEPART(Hour, GetDate()) AS varchar)
SET @min = CAST(DATEPART(MINUTE, GetDate()) AS varchar)
EXEC xp_sprintf @BackUpPrefix OUTPUT, '%04s%01s%02s%01s%02s%01s%02s%01s%02s', @year, '_', @month, '_', @day, '___', @hour, '_', @min

SET @Command = 'echo -------------------------------------------------------> "' + @DirPath + 'Log.txt"'
EXEC master..xp_cmdshell @Command

--        :
DECLARE Step_cursor CURSOR FOR SELECT [Name] FROM master..sysdatabases WHERE 
-->>**************************************************************************************
--        
([Name]<>'tempdb') AND ([Name]<>'master') AND ([Name]<>'model') AND ([Name]<>'ReportServer') AND ([Name]<>'ReportServerTempDB') AND ([Name]<>'msdb') AND ([Name]<>'zuptemp')
--<<**************************************************************************************
OPEN Step_cursor
FETCH NEXT FROM Step_cursor INTO @DataBaseName
WHILE @@FETCH_STATUS = 0 BEGIN 
	--         
	--     ,   :
	SET @year	= CAST(DATEPART(Year, GetDate()) AS varchar)
	SET @month	= CAST(DATEPART(Month, GetDate()) AS varchar)
	SET @day	= CAST(DATEPART(Day, GetDate()) AS varchar)
	SET @hour	= CAST(DATEPART(Hour, GetDate()) AS varchar)
	SET @min	= CAST(DATEPART(MINUTE, GetDate()) AS varchar)
	EXEC xp_sprintf @S OUTPUT, '%04s%01s%02s%01s%02s%01s%02s%01s%02s', @year, '_', @month, '_', @day, '___', @hour, '_', @min
	SET @Command = 'echo --- Start backup ' + @DataBaseName + '---' + @S + '>> "' + @DirPath + 'Log.txt"'
	EXEC master..xp_cmdshell @Command

	--    
    SET @BackUpPath = @DirPath + @BackUpPrefix + '_' + @DataBaseName + '.bak'
    --     ( bak-):
    BACKUP DATABASE @DataBaseName TO DISK = @BackUpPath WITH NOFORMAT, COMPRESSION, INIT, SKIP
	                  
    -----------------------------------------------------------------------------------------
    --     FTP
    SET @Command = 'echo open "' + @FtpServer + '"> "' + @DirPath + 'Script.txt"'
    EXEC master..xp_cmdshell @Command
    --   
	SET @Command = 'echo quote user ' + @FtpUser + '>> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command
	--  
	SET @Command = 'echo quote pass ' + @FtpPassword+ '>> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command
	--    
	SET @Command = 'echo lcd "' + @DirPath + '">> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command
	
	--      (         )
	SET @Command = 'echo mkdir "' + @FtpFolder + '">> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command	
	--     
	SET @Command = 'echo cd "' + @FtpFolder + '">> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command

	--      (         )
	SET @Command = 'echo mkdir "' + @ServerName + '">> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command	
	--     
	SET @Command = 'echo cd "' + @ServerName + '">> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command
	
	--      (         )
	SET @Command = 'echo mkdir "' + @DataBaseName + '">> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command	
	--      
	SET @Command = 'echo cd "' + @DataBaseName + '">> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command
	
	--    
	SET @Command = 'echo bin>> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command
	--     
	SET @Command = 'echo mput "' + @BackUpPath + '" >> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command
		
	-- ,        ...
	SET @Command = 'echo bye>> "' + @DirPath + 'Script.txt"'
	EXEC master..xp_cmdshell @Command
	
	-----------------------------------------------------------------------------------------
	--         
	--     ,   :
	SET @year	= CAST(DATEPART(Year, GetDate()) AS varchar)
	SET @month	= CAST(DATEPART(Month, GetDate()) AS varchar)
	SET @day	= CAST(DATEPART(Day, GetDate()) AS varchar)
	SET @hour	= CAST(DATEPART(Hour, GetDate()) AS varchar)
	SET @min	= CAST(DATEPART(MINUTE, GetDate()) AS varchar)
	EXEC xp_sprintf @S OUTPUT, '%04s%01s%02s%01s%02s%01s%02s%01s%02s', @year, '_', @month, '_', @day, '___', @hour, '_', @min
	SET @Command = 'echo --- Send to FTP ' + @DataBaseName + ' --- ' + @S + '>> "' + @DirPath + 'Log.txt"'
	EXEC master..xp_cmdshell @Command
	
	--   ftp   
	SET @Command = 'ftp -i -n -s:"' + @DirPath + 'Script.txt" ' + @FtpServer + ':' + @FtpPort + '>> "' + @DirPath + 'Log.txt"'
	EXEC @result = master..xp_cmdshell @Command
	
	-----------------------------------------------------------------------------------------
	--     ,  ?
	IF( @result = 0)
	BEGIN
		-----------------------------------------------------------------------------------------
		--   
		SET @Command = 'del "' + @BackUpPath +  '" /Q' + ' /F'
		EXEC master..xp_cmdshell @Command	
	END
	ELSE
	BEGIN
		--  
		SET @year = CAST(DATEPART(Year, GetDate()) AS varchar)
		SET @month = CAST(DATEPART(Month, GetDate()) AS varchar)
		SET @day = CAST(DATEPART(Day, GetDate()) AS varchar)
		SET @hour = CAST(DATEPART(Hour, GetDate()) AS varchar)
		SET @min = CAST(DATEPART(MINUTE, GetDate()) AS varchar)
		EXEC xp_sprintf @S OUTPUT, '%02s%01s%02s%01s%04s%01s%02s%01s%02s', @day, '.', @month, '.', @year, ' ', @hour, ':', @min
		SET @Command = '      "' + @DataBaseName + '"  ' + @S + '   ' + @ServerName;
		EXEC master..xp_sendmail @recipients=@MailForError,
			@subject=@Command,
			@message=N'       .'
		
		--   
		SET @Command = 'del "' + @DirPath + 'Script.txt"' +  '" /Q' + ' /F'
		EXEC master..xp_cmdshell @Command	
    END
	
    FETCH NEXT FROM Step_cursor INTO @DataBaseName
END
CLOSE Step_cursor
DEALLOCATE Step_cursor